/*=============================================================================/
/                                                                              /
/                            PPIvOC`wb_                           /
/                                                                              /
/                         Palette Operator PPI-Plugin SDK                      /
/               Copyright (C)2005 Advangate. All rights reserved.              /
/=============================================================================*/
#ifndef	_PALOPEPLUGIN_H_
#define	_PALOPEPLUGIN_H_
#include <Windows.h>
#ifdef	__cplusplus
extern "C" {
#endif


/*=============================================================================/
/                                     ^`                                   /
/=============================================================================*/
#ifndef PALOPE_DEFINED_TYPES
#define PALOPE_DEFINED_TYPES
typedef	signed  char		Sint8;
typedef	unsigned char		Uint8;
typedef	short				Sint16;
typedef	unsigned short		Uint16;
typedef	int					Sint32;
typedef	unsigned int		Uint32;
typedef	__int64				Sint64;
typedef	unsigned __int64	Uint64;
typedef	float				Float32;
typedef	double				Float64;
#endif // PALOPE_DEFINED_TYPES


/*=============================================================================/
/                            vOCdlo[W                          /
/=============================================================================*/
#define	PPI_SPEC_VERSION		0x00010000					/* Ver. 1.00.00 */


/*=============================================================================/
/                                    ėp`                                  /
/=============================================================================*/
#define	PPIEXPT		__declspec(dllexport)
#define PPIAPI		__cdecl

#ifdef PPI_HOST_BUILD
#define	PPICONST
#else
#define	PPICONST	const
#endif

/*=============================================================================/
/                             vV[W^Cv`                           /
/=============================================================================*/
typedef enum {
	PPIPRC_FILE_LOAD = 1,									/* t@C[hvV[W */
	PPIPRC_FILE_SAVE,										/* t@CZ[uvV[W */
} PpiProcType;


/*=============================================================================/
/                                 G[ԍ`                               /
/=============================================================================*/
typedef enum {
	PPIERR_OK = 0,											/* G[(OK) */
	PPIERR_NOT_ENOUGH_MEM,									/* [sĂ */
	PPIERR_FILE_ERR,										/* t@CANZXŃG[ */
	PPIERR_DATA_BROKEN,										/* f[^Ă (t@C[ĥ) */
	PPIERR_ERROR,											/* ̑̃G[ */
	PPIERR_CANCELED,										/* fꂽ */
	
	PPIERR_MAX												/* G[ԍ`(̒lԂĂ͂Ȃ) */
} PpiErr;


/*=============================================================================/
/                              zXg摜f[^`                            /
/------------------------------------------------------------------------------/
/ zXg摜f[^\                                                         /
/                                                                              /
/   zXg摜                                C[Wf[^             /
/                                          /
/   PpiHostPict   ImgData PpiImgData[0]            /
/                 PalData                        /
/             pbgf[^    PpiImgData[1]            /
/                                          /
/                             PpiPalData[0]         .                  /
/                                     .                  /
/                             PpiPalData[1]         .                  /
/                                          /
/                                   .         PpiImgData[MipMapLevCnt-1] /
/                                   .                    /
/                                   .                                      /
/                                                            /
/                             PpiPalData[PalBankCnt-1]                       /
/                                                            /
/                                                                              /
/   C[Wf[^                                                       /
/                                                            /
/   PpiImgData     ImgBuf              /
/    ImgBufDir         C[Wobt@          /
/                      ImgBufIdx        ------------------------------   /
/                                         PPIIMGTP_DIRECT̃TCY        /
/                                          Width*Height*sizeof(PpiRGBA)    /
/                                                                          /
/                                         PPIIMGTP_INDEX̃TCY         /
/                                          Width*Height*sizeof(PpiIDXCOL)    /
/                                            /
/                                                                              /
/   pbgf[^                                                       /
/                          /
/   PpiPalData     PalBuf        pbgobt@          /
/                       ------------------------------   /
/                                         obt@TCY                   /
/                                          PalColCnt*sizeof(PpiRGBA)       /
/                                            /
/                                                                              /
/=============================================================================*/
/* -------- sNZJ[` -------- */
/* qfa`J[ */
typedef union {
	/* evfŃANZX */
	struct {
		Uint8	r;											/*  (Red) */
		Uint8	g;											/*  (Green) */
		Uint8	b;											/*  (Blue) */
		Uint8	a;											/* At@ (Alpha) */
	};
	/* 32rbgANZX */
	Uint32		abgr;										/* 32rbgŃANZXꍇ 0xAABBGGRR ̕ */
} PpiRGBA;
/* CfbNXJ[ */
typedef struct {
	Uint8		idx;										/* pbgCfbNXԍ */
	Uint8		_reserved_;									/* U[u (ANZX֎~) */
} PpiIDXCOL;

/* -------- C[W^Cv` -------- */
typedef enum {
	PPIIMGTP_DIRECT,										/* _CNgJ[摜 */
	PPIIMGTP_INDEX,											/* CfbNXJ[摜 */
} PpiImgType;

/* -------- C[Wf[^ -------- */
typedef struct {
	PPICONST Uint32			Width;							/* C[W̕ */
	PPICONST Uint32			Height;							/* C[W̍ */
	PPICONST Uint32			BufSize;						/* ImgBuf Ɋmۂꂽobt@[e(oCg) */
	union {
		Uint8* PPICONST		ImgBuf;							/* C[Wf[^̊i[ */
		PpiRGBA* PPICONST	ImgBufDir;						/* _CNgJ[ŃANZX */
		PpiIDXCOL* PPICONST	ImgBufIdx;						/* CfbNXJ[ŃANZX */
	};
	PPICONST Uint32			_reserved_[4];					/* U[u (ANZX֎~) */
} PpiImgData;

/* -------- pbgf[^ -------- */
typedef struct {
	PPICONST Uint32			BufSize;						/* PalBuf Ɋmۂꂽobt@[e(oCg) */
	PpiRGBA* PPICONST		PalBuf;							/* pbgf[^̊i[ */
	PPICONST Uint32			_reserved_[6];					/* U[u (ANZX֎~) */
} PpiPalData;

#define	PPI_PALBNK_MAX					(100)				/* őpbgoN */
#define	PPI_PALCOL_MAX					(256)				/* őpbgJ[o^ */

/* -------- zXg摜EtO` (PpiHostPict.Flag) -------- */
#define	PPIHSTIG_FLG_ALPHA				(1<<0)				/* At@`lĂ */

/* -------- zXg摜 -------- */
typedef struct {
	PPICONST Uint32			Flag;							/* tO (PPIHSTIG_FLG_` Œ`ꂽl) */
	PpiRGBA					ColBitDepth;					/* Frbg[x (r,g,b:e1`8 / a:0`8) */
	/* C[W */
	PPICONST Uint8			Type;							/* C[W^Cv (PpiImgType) */
	PPICONST Uint8			_reserved_[3];					/* U[u (ANZX֎~) */
	PPICONST Uint32			MipMapLevCnt;					/* ~bv}bvx(C[W) */
	PpiImgData*	PPICONST 	ImgData;						/* C[Wf[^ */
	/* pbg */
	PPICONST Uint32			PalBankCnt;						/* pbgoN */
	PPICONST Uint32			PalColCnt;						/* Ppbg̃J[o^ */
	PpiPalData*	PPICONST 	PalData;						/* pbgf[^ */
	/* U[u (ANZX֎~) */
	PPICONST Uint32			_reserved2_[24];
} PpiHostPict;


/*=============================================================================/
/                            vOCf[^`                          /
/=============================================================================*/
typedef struct {
	Uint32			SpecVersion;							/* vOCdlo[W (K PPI_SPEC_VERSION w) */
	LPCSTR			PluginName;								/* vOC */
	LPCSTR			PluginVerCpy;							/* o[WRs[Cg\p */
	Uint32			_reserved_[5];							/* U[u (ANZX֎~) */
} PpiPluginInfoData;

/* -------- f[^ݒ}N -------- */
/*
		name   : vOCւ̃|C^
		vercpy : o[WRs[Cg\pւ̃|C^
*/
#define	PLGIFDATA(name, vercpy)		{ PPI_SPEC_VERSION, (name), (vercpy), 0,0,0,0,0 }


/*=============================================================================/
/                           vV[Wf[^`                         /
/=============================================================================*/
typedef struct {
	PpiProcType		ProcType;								/* vV[W^Cv */
	Uint32			ProcID;									/* vV[Whcԍ */
	LPCSTR			ProcName;								/* vV[W */
	Uint32			Caps;									/* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
	Uint32			_reserved_[4];							/* U[u (ANZX֎~) */
	/* evV[W^Cvp[^ */
	union {
		/* ŒTCŸm */
		Uint32		_paramAreaAlloc[8];						/* ̃o͎gp֎~ */
		/* t@CLOAD,SAVEvV[Wp */
		struct {
			LPCSTR			FilterName;						/* tB^[ ( "BMPt@C") */
			LPCSTR			FilterPattern;					/* tB^[p^[ ( "*.bmp;*.dib") */
		};
	};
} PpiProcInfoData;

/* -------- vV[Wf[^E\̓tO (PpiProcInfoData.Caps) -------- */
#define	PRCIDCAPS_IMAGE_DIR				(1<<0)				/* C[Wi_CNgJ[jɑΉł */
#define	PRCIDCAPS_IMAGE_IDX				(1<<1)				/* C[WiCfbNXJ[jɑΉł */
#define	PRCIDCAPS_ONLY_PAL				(1<<2)				/* pbĝ݉摜ɑΉł */
#define	PRCIDCAPS_PALBANK				(1<<3)				/* ̃pbgoNɑΉł */
#define	PRCIDCAPS_ALPHA					(1<<4)				/* At@`lɑΉł */
#define	PRCIDCAPS_MIPMAP				(1<<5)				/* ~bv}bvɑΉł */
#define PRCIDCAPS_OPTIONS				(1<<6)				/* IvVݒ͗L */

/* -------- f[^ݒ}N -------- */
/* t@C[hvV[W
		id   : vV[Whcԍ
		name : vV[W
		caps : \̓tO
		flnm : tB^[ ( "BMPt@C")
		flpt : tB^[p^[ ( "*.bmp;*.dib")
*/
#define	PRCIFDATA_LOAD(id, name, caps, flnm, flpt) \
			{ PPIPRC_FILE_LOAD, (id), (name), (caps), 0,0,0,0, { (Uint32)(flnm), (Uint32)(flpt), 0,0,0,0,0,0 } }

/* t@CZ[uvV[W
		id   : vV[Whcԍ
		name : vV[W
		caps : \̓tO
		flnm : tB^[ ( "BMPt@C")
		flpt : tB^[p^[ ( "*.bmp;*.dib")
*/
#define	PRCIFDATA_SAVE(id, name, caps, flnm, flpt) \
			{ PPIPRC_FILE_SAVE, (id), (name), (caps), 0,0,0,0, { (Uint32)(flnm), (Uint32)(flpt), 0,0,0,0,0,0 } }

/* I[f[^
		K̃}NgI[`Kv܂B
*/
#define	PRCIFDATA_TERM()	{ (PpiProcType)0,0,0,0,0,0,0,0,{0,0,0,0,0,0,0,0} }


/*=============================================================================/
/                                  zXg`oh                                /
/=============================================================================*/
typedef struct tagPpiPrcContext PpiPrcContext;

/* zXg摜쐬
	PpiErr PPIAPI PpiHaCreateHostPict(PpiPrcContext* ctx, Uint32 flg, PpiImgType type,
									 Uint32 w, Uint32 h, Uint32 mmc,
									 Uint32 palbnkc, Uint32 palcolc)
	
		PpiPrcContext*	ctx     : vV[WReLXg
		Uint32			flg     : tO (PPIHSTIG_FLG_` Œ`ꂽl)
		PpiImgType		type	: C[W^Cv
		Uint32			w       : C[W̉i~bv}bvx0̉摜j
		Uint32			h       : C[W̍i~bv}bvx0̉摜j
		Uint32			mmc     : ~bv}bvx(摜)
		Uint32			palbnkc : pbgoN (_CNgJ[摜̏ꍇ0)
		Uint32			palcolc : Ppbg̃J[o^ (_CNgJ[摜̏ꍇ0)
	߂l
		PpiErr			        : G[e  (PPIERR_OK ̏ꍇ͍쐬)
	
		Ŏw肳ꂽ`̉摜f[^iC[Wpbgj̏쐬Aobt@mۂ܂B
		w, h Ŏw肳C[W̕A͒ʏ͉摜̃TCYw肵܂A~bv}bv̏ꍇɂ
		ł傫摜i~bv}bvx0̉摜j̃TCYw肵܂B
		~bv}bv̏ꍇAmmc Ŏw肳ꂽi~bv}bv摜̖j̃C[Wf[^mۂ܂B
		܂A~bv}bvx1ȍ~i2ڈȍ~j̉摜̃TCY͎vZ܂iw, h ̂1/2
		čs܂jB~bv}bv͕ATPQsNZȉłQׂ̂̏ꍇ̂ݗLłBȊO
		̏ꍇ傫mmc̒l̏ꍇALȖ̂ݍ쐬܂B
		pbggpȂꍇi_CNgJ[̏ꍇ̂݁j palbnkc, palcolc ɂ 0 ZbgĉB
		쐬ꂽC[Wobt@Apbgobt@́uF͍(0,0,0)vu͕svŏĂ܂B
*/
#define	PpiHaCreateHostPict(ctx, flg, type, w, h, mmc, palbnkc, palcolc) \
               (ctx)->ApiCreateHostPict(    ctx,            flg,    type,       w,      h,      mmc,    palbnkc, palcolc)
typedef PpiErr (PPIAPI *PHA_CreateHostPict)(PpiPrcContext* ,Uint32, PpiImgType, Uint32, Uint32, Uint32, Uint32,  Uint32);


/* vOX
	BOOL PPIAPI PpiHaProgress(PpiPrcContext* ctx, Sint32 percent)
	
		PpiPrcContext*	ctx     : vV[WReLXg
		Sint32			percent	: is󋵂̃p[Zgl (0`100)
	߂l
		BOOL					: LZv (TRUȄꍇLZvL)
	
		ǂݏo(PpiFileLoadExec())Aۑ(PpiFileSaveExec())A̐is󋵂zXgɘA܂B
		percent ɂ͐is 0%`100% ŕ\p[Zgln܂B
		(0`100ȊOnꍇ0`100ɃNv܂)
		߂l TRUE Ԃꍇɂ́ALZv̂ŃvOC݂͌̏𒆎~ĉB
		܂ALZꍇ PPIERR_CANCELED Ԃ悤ɂĉB
*/
#define	PpiHaProgress(ctx, percent) \
               (ctx)->ApiProgress(  ctx,            percent)
typedef BOOL (PPIAPI *PHA_Progress)(PpiPrcContext* ,Sint32);


/*=============================================================================/
/                             vOCReLXg                           /
/=============================================================================*/
/* -------- vOCReLXg\ -------- */
typedef struct tagPpiPlgContext{
	PPICONST HINSTANCE		InstHdl;						/* vOC̃CX^Xnh */
	PPICONST HWND 			WndHdl;							/* zXgAvP[ṼEBhEnh */
	PPICONST PpiPluginInfoData* PPICONST PlgIfDt;			/* vOCf[^ */
	PPICONST PpiProcInfoData* PPICONST   PrcIfDt;			/* vV[Wf[^ */
} PpiPlgContext;


/*=============================================================================/
/                            vV[WReLXg                          /
/=============================================================================*/
/* -------- vV[WReLXg\ -------- */
typedef struct tagPpiPrcContext{
	PPICONST PpiPlgContext* PlgCtx;							/* vOCReLXg */
	PPICONST PpiProcInfoData* PPICONST PrcIfDt;				/* vV[Wf[^(̃vV[W̏) */
	PPICONST Uint32 		ProcID;							/* vV[Whcԍ */
	PPICONST BOOL 			CanUseUI;						/* TRUE ̏ꍇ͂thgp\ */
	PPICONST Uint32			DispMmlv;						/* \~bv}bvx(SAVEɕKvȂΎQƉ\) */
	PPICONST Uint32			DispPalBnk;						/* \pbgoN(SAVEɕKvȂΎQƉ\) */
	/* zXg摜 */
	PpiHostPict			 	HostPict;						/* zXg摜 */
	/* zXg`oh */
	PHA_CreateHostPict PPICONST		ApiCreateHostPict;		/* zXg摜쐬 */
	PHA_Progress PPICONST			ApiProgress;			/* vOX */
} PpiPrcContext;


/*=============================================================================/
;                             t@Cp[^                            
/=============================================================================*/
/* -------- ` -------- */
#define	PPCTX_MAX_PATH			(260)						/* t@C̍ő̒ */
#define	PPCTX_FILEHEADBUF_SIZE	(2048)						/* t@Cwb_obt@̃TCY */

/* -------- t@Cp[^\ -------- */
typedef struct {
	PPICONST CHAR			FileName[PPCTX_MAX_PATH];		/* t@C			  ( "c:\aaaa\bbbb.ccc") */
	PPICONST CHAR			FilePath[PPCTX_MAX_PATH];		/* t@C̃pX   ( "c:\aaaa") Ō'\'͕tȂ */
	PPICONST CHAR			FileFullTitle[PPCTX_MAX_PATH];	/* t@C̑S^Cg ( "bbbb.ccc") */
	PPICONST CHAR			FileTitle[PPCTX_MAX_PATH];		/* t@C̃^Cg   ( "bbbb") */
	PPICONST CHAR			FileExt[PPCTX_MAX_PATH];		/* t@C̊gq       ( "ccc") '.'͊܂܂Ȃ */
	PPICONST Uint8			FileHeadBuf[PPCTX_FILEHEADBUF_SIZE]; /* t@Cwb_obt@ (t@C[ĥݗL) */
} PpiFileInf;


/*=============================================================================/
/                          vOC`ohvg^Cv                        /
/=============================================================================*/
/* --------  -------- */
/* vOC̐ڑ (K{) */
PPIEXPT BOOL PPIAPI PpiConnectPlugin(PpiPlgContext* plgctx, PpiPluginInfoData** plgifdt, PpiProcInfoData** prcifdt);
/* vOC̐ؒf */
PPIEXPT void PPIAPI PpiDisconnectPlugin(PpiPlgContext* plgctx);
/* vV[W̐ڑ */
PPIEXPT BOOL PPIAPI PpiConnectProc(PpiPrcContext* prctx);
/* vV[W̐ؒf */
PPIEXPT void PPIAPI PpiDisconnectProc(PpiPrcContext* prctx);
/* AoEg\ */
PPIEXPT void PPIAPI PpiDispAbout(PpiPlgContext* plgctx);

/* -------- t@C[hvV[Wp -------- */
/* t@C[hp̃IvVݒ */
PPIEXPT PpiErr PPIAPI PpiFileLoadOptions(PpiPrcContext* prctx, PpiFileInf* fileinf);
/* t@C[h̑Ή`FbN (K{) */
PPIEXPT BOOL PPIAPI PpiFileLoadChkSupport(PpiPrcContext* prctx, PpiFileInf* fileinf);
/* t@C[h̃t@C̓ǂݏo (K{) */
PPIEXPT PpiErr PPIAPI PpiFileLoadExec(PpiPrcContext* prctx, PpiFileInf* fileinf);

/* -------- t@CZ[uvV[Wp -------- */
/* t@CZ[up̃IvVݒ */
PPIEXPT PpiErr PPIAPI PpiFileSaveOptions(PpiPrcContext* prctx, PpiFileInf* fileinf);
/* t@CZ[ũt@C֕ۑ (K{) */
PPIEXPT PpiErr PPIAPI PpiFileSaveExec(PpiPrcContext* prctx, PpiFileInf* fileinf);



#ifdef	__cplusplus
}
#endif	/* __cplusplus */
#endif	/* _PALOPEPLUGIN_H_ */
/* ---------------- EOF ---------------- */
