/*=============================================================================/
/                                                                              /
/                            POXtH[}bgTv                           /
/                                                                              /
/                         Palette Operator PPI-Plugin SDK                      /
/               Copyright (C)2005 Advangate. All rights reserved.              /
/------------------------------------------------------------------------------/
/ Tv                                                                   /
/      POXt@CtH[}bgTvvOB                       /
/      POXt@CBMPt@CɕϊB                                  /
/                                                                              /
/ g                                                                     /
/      pox2bmp pox-file bmp-file                                               /
/           pox-file  bmp-file ֕ϊB                                /
/           pbgoN0A~bv}bvx0gpB                   /
/           _CNgJ[24bppACfbNXJ[8bppŕۑB  /
/=============================================================================*/
#include <memory.h>
#include <stdio.h>
#include "..\..\..\include\PoxFmt.h"

/* BMPtH[}bg̒`p */
#include <Windows.h>


/*=============================================================================/
/                              POXBMPɕϊ                            /
/=============================================================================*/
int pox2bmp(char* poxfname, char* bmpfname)
{
	FILE*	ifp = NULL;
	FILE*	ofp = NULL;
	PoxHead	pox;
	PoxPict* pic = &pox.Pict;
	BITMAPFILEHEADER fh;
	BITMAPINFOHEADER ih;
	Uint32	headsize, pixsz, rowsz, padsz;
	PoxImgData imgdat;
	Uint32 mmlv = 0;										/* ۑΏۂ̃~bv}bvx */
	Uint32 palbnk = 0;										/* ۑΏۂ̃pbgoN */

	/* POXt@CJ */
   	if((ifp = fopen(poxfname,"rb")) == NULL){
		fprintf(stderr, "t@CJ܂\n  %s\n", poxfname);
		return -1;
	}
	/* POXwb_̓ǂݏo */
	if(fread(&pox, 1, sizeof(PoxHead), ifp) != sizeof(PoxHead)){
		fprintf(stderr, "POXwb_ǂ߂܂\n");
		return -1;
	}
	/* POXtH[}bg`FbN */
	if(pox.Sig.SigVal != POXFMT_SIG_INT){
		fprintf(stderr, "POXt@Cł͂܂\n");
		return -1;
	}
	if(pox.Sig.SpecVer > POXFMT_SPEC_VER){
		fprintf(stderr, "Ή̃o[Wł\n");
		return -1;
	}
	/* POẌُx`FbN (܂͑ΉȂ``FbN) */
	if(pic->MipMapLevCnt == 0){
		/* upbĝ݉摜vɂ͑ΉȂ */
		fprintf(stderr, "POXt@Cɉ摜܂\n");
		return -1;
	}
	if(pic->Type == POXIMGTP_INDEX){
		if((pic->PalBankCnt == 0) || (pic->PalColCnt == 0)){
			fprintf(stderr, "POXt@CɃpbg܂\n");
			return -1;
		}
	}
	/* C[Wf[^擾 */
	if(fseek(ifp, ((Uint32)pic->ImgData) + (sizeof(PoxImgData) * mmlv), SEEK_SET)){
		fprintf(stderr, "t@Cǂ߂܂\n");
		return -1;
	}
	if(fread(&imgdat, 1, sizeof(PoxImgData), ifp) != sizeof(PoxImgData)){
		fprintf(stderr, "t@Cǂ߂܂\n");
		return -1;
	}
	if((imgdat.Width == 0) || (imgdat.Height == 0)){
		fprintf(stderr, "POXt@C̉摜TCYُł\n");
		return -1;
	}

	/* BMPt@CJ */
   	if((ofp = fopen(bmpfname,"wb")) == NULL){
		/* t@CJȂ */
		fprintf(stderr, "t@CJ܂\n  %s\n", bmpfname);
		return -1;
	}
	/* wb_{pbg̃TCY߂ */
	headsize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	if(pic->Type == POXIMGTP_INDEX){
		headsize += pic->PalColCnt * sizeof(RGBQUAD);
	}
	/* BITMAPFILEHEADER o */
	pixsz = (pic->Type == POXIMGTP_INDEX)? 1 : 3;
	rowsz = (pixsz * imgdat.Width + 3) & (~3);
	padsz = rowsz - (pixsz * imgdat.Width);
	memset(&fh, 0, sizeof(BITMAPFILEHEADER));
	fh.bfType = 0x4d42;
	fh.bfSize = headsize + rowsz * imgdat.Height;
	fh.bfOffBits = headsize;
	if(fwrite(&fh, 1, sizeof(BITMAPFILEHEADER), ofp) != sizeof(BITMAPFILEHEADER)){
		fprintf(stderr, "t@Cɏ߂܂\n");
		return -1;
	}
	/* BITMAPINFOHEADER o */
	memset(&ih, 0, sizeof(BITMAPINFOHEADER));
	ih.biSize = sizeof(BITMAPINFOHEADER);
	ih.biWidth	= imgdat.Width;
	ih.biHeight = imgdat.Height;
	ih.biPlanes = 1;
	ih.biBitCount = (pic->Type == POXIMGTP_INDEX)? 8 : 24;
	ih.biCompression = BI_RGB;
	ih.biSizeImage = 0;
	ih.biClrUsed = (pic->Type == POXIMGTP_INDEX)? pic->PalColCnt : 0;
	if(fwrite(&ih, 1, sizeof(BITMAPINFOHEADER), ofp) != sizeof(BITMAPINFOHEADER)){
		fprintf(stderr, "t@Cɏ߂܂\n");
		return -1;
	}

	/* pbgo */
	if(pic->Type == POXIMGTP_INDEX){
		PoxPalData paldat;
		Uint32 idx;
		RGBQUAD rgbq;
		PoxRGBA rgba;
		/* pbgf[^擾 */
		if(fseek(ifp, ((Uint32)pic->PalData) + (sizeof(PoxPalData) * palbnk), SEEK_SET)){
			fprintf(stderr, "t@Cǂ߂܂\n");
			return -1;
		}
		if(fread(&paldat, 1, sizeof(PoxPalData), ifp) != sizeof(PoxPalData)){
			fprintf(stderr, "t@Cǂ߂܂\n");
			return -1;
		}
		/* pbgf[^ֈړ */
		if(fseek(ifp, (Uint32)paldat.PalBuf, SEEK_SET)){
			fprintf(stderr, "t@Cǂ߂܂\n");
			return -1;
		}
		/* pbgۑ */
		rgbq.rgbReserved = 0;
		for(idx = 0; idx < pic->PalColCnt; idx++){
			/* PF擾 */
			if(fread(&rgba, 1, sizeof(PoxRGBA), ifp) != sizeof(PoxRGBA)){
				fprintf(stderr, "t@Cǂ߂܂\n");
				return -1;
			}
			/* ۑ */
			rgbq.rgbRed = rgba.r;
			rgbq.rgbGreen = rgba.g;
			rgbq.rgbBlue = rgba.b;
			if(fwrite(&rgbq, 1, sizeof(RGBQUAD), ofp) != sizeof(RGBQUAD)){
				fprintf(stderr, "t@Cɏ߂܂\n");
				return -1;
			}
		}
	}

	/* 摜o({gAbv) */
	{
		Uint32 x, y;
		Uint32 poxpixsz = (pic->Type == POXIMGTP_INDEX)? sizeof(PoxIDXCOL) : sizeof(PoxRGBA);
		Uint8 buf[4];
		for(y = imgdat.Height; y > 0; y--){
			/* POXt@C̃C[Wf[^փV[N */
			if(fseek(ifp, ((Uint32)imgdat.ImgBuf) + (y-1) * imgdat.Width * poxpixsz, SEEK_SET)){
				fprintf(stderr, "t@Cǂ߂܂\n");
				return -1;
			}
			/* PCo */
			for(x = 0; x < imgdat.Width; x++){
				if(pic->Type == POXIMGTP_DIRECT){
					/* _CNgJ[摜̕ۑ */
					PoxRGBA col;
					/* POXt@ĈPsNZ擾 */
					if(fread(&col, 1, sizeof(PoxRGBA), ifp) != sizeof(PoxRGBA)){
						fprintf(stderr, "t@Cǂ߂܂\n");
						return -1;
					}
					/* ۑ */
					buf[0] = col.b;
					buf[1] = col.g;
					buf[2] = col.r;
					if(fwrite(buf, 1, 3, ofp) != 3){
						fprintf(stderr, "t@Cɏ߂܂\n");
						return -1;
					}
				} else {
					/* CfbNXJ[摜̕ۑ */
					PoxIDXCOL col;
					/* POXt@ĈPsNZ擾 */
					if(fread(&col, 1, sizeof(PoxIDXCOL), ifp) != sizeof(PoxIDXCOL)){
						fprintf(stderr, "t@Cǂ߂܂\n");
						return -1;
					}
					/* ۑ */
					buf[0] = col.idx;
					if(fwrite(buf, 1, 1, ofp) != 1){
						fprintf(stderr, "t@Cɏ߂܂\n");
						return -1;
					}
				}
			}
			/* pfBO */
			if(padsz){
				Uint32 padval = 0;
				if(fwrite(&padval, 1, padsz, ofp) != padsz){
					fprintf(stderr, "t@Cɏ߂܂\n");
					return -1;
				}
			}
		}
	}

	/* I */
	fclose(ifp);
	fclose(ofp);
	return 0;
}


/*=============================================================================/
/                                    main֐                                  /
/=============================================================================*/
int main(int argc, char** argv)
{
	/* wv\ */
	if(argc == 1){
		printf("POXt@CBMPt@C֕ϊTvvO\n");
		printf("Copyright (C)2005 Advangate. All rights reserved.\n");
		printf("usage: pox2bmp pox-file bmp-file\n");
		printf("         pox-file : POXt@C\n");
		printf("         bmp-file : o͂BMPt@C\n");
		return -1;
	}

	/* `FbN */
	if(argc != 3){
		fprintf(stderr, "̌ُł\n");
		return -1;
	}

	/* POXBMPɕϊ */
	return pox2bmp(argv[1], argv[2]);
}



